** assumes that image and file are stored in same &OUTPATH folder;
ods html close;
title;
   
ods html(id=ex1) file="&outpath\example1_COMPUTE_BEFORE_PAGE.html";
proc report data=shoes spanrows;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 1a) COMPUTE BEFORE/AFTER _PAGE_';
  column region product sales returns Profit inventory PctInv ;
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before _page_ / style={background=white preimage="&outpath\shoe_zoo.png"};
     line ' ';
  endcomp;
  compute after _page_ / style={background=white preimage="&outpath\shoe_zoo.png"};
     line ' ';
  endcomp;
run;

proc report data=shoes spanrows;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 1b) COMPUTE BEFORE/AFTER _PAGE_';
  column region product sales returns Profit inventory PctInv ;
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before _page_ / style=Header{fontweight=bold fontsize=18pt};
     line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
  compute after _page_ / style=Header{fontweight=bold fontsize=18pt};
     line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
run;

ods html(id=ex1) close;

  
ods html(id=ex1by) file="&outpath\example1_COMPUTE_BEFORE_PAGE_BY.html";

proc report data=shoes spanrows;
by region;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 1c) COMPUTE BEFORE/AFTER _PAGE_';
  column region product sales returns Profit inventory PctInv ;
  
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before _page_ / style=Header{fontweight=bold fontsize=18pt};
     line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
  compute after _page_ / style=Header{fontweight=bold fontsize=18pt};
     line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
run;
ods _all_ close;

ods html(id=ex1pg) file="&outpath\example1_COMPUTE_BEFORE_PAGE_PG.html";

proc report data=shoes spanrows;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 1d) COMPUTE BEFORE/AFTER _PAGE_';
  column region product sales returns Profit inventory PctInv ;
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize page;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before _page_ / style=Header{fontweight=bold fontsize=18pt};
     line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
  compute after _page_ / style=Header{fontweight=bold fontsize=18pt};
     line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
run;
ods _all_ close;


ods html(id=bonus) file="&outpath\example1_COMPUTE_BEFORE_PAGE_region.html";

proc report data=shoes spanrows;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 1e) Alter Break Line Value for Region';
  column region product sales returns Profit inventory PctInv ;
  define region / group;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize page;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute region;
     if upcase(_break_) = 'REGION' then do;
        region = catx(' ',region, 'Total');
	 end;
	 else if _break_ in ('_RBREAK_') then do;
	   region = 'Grand Total';
	 end;
  endcomp;
  compute before _page_ / style=Header{fontweight=bold fontsize=18pt};
	 line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
  compute after _page_ / style=Header{fontweight=bold fontsize=18pt};
	 line "Shoe Zoo: We've got everything from boots to bunny slippers!";
  endcomp;
run;
ods _all_ close;

ods html;
title;


