title; footnote;

ods html(id=err) file="&outpath\example3_error.html";

proc report data=shoes spanrows
     style(summary)=Header;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 3a) COMPUTE BEFORE With Custom Header';
  column region product sales returns Profit inventory PctInv ;
  define region / display noprint;
  define product / display;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before region/ style=Header{just=l fontweight=bold fontsize=12pt};
     length brkline $100;
	 brkline = catx(' ','Region: ',region);
     line brkline $varying100.;
  endcomp;
run;

ods html(id=err) close;
   
ods html(id=ex3) file="&outpath\example3_COMPUTE_BEFORE_target.html";

proc report data=shoes spanrows
     style(summary)=Header;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 3a) COMPUTE BEFORE With Custom Header';
  column region product sales returns Profit inventory PctInv ;
  define region / group noprint;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before region/ style=Header{just=l fontweight=bold fontsize=12pt};
     length brkline $100;
	 brkline = catx(' ','Region: ',region);
     line brkline $varying100.;
  endcomp;
run;

ods html(id=ex3) close;

   
 
ods html(id=ex3b) file="&outpath\example3_COMPUTE_AFTER_target.html";

proc report data=shoes spanrows
     style(summary)=Header;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 3b1) COMPUTE BEFORE/AFTER with LINE';
  column region product sales returns Profit inventory PctInv ;
  define region / group noprint;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before region/ style=Header{just=c fontweight=bold fontsize=12pt};
     line region $varying100.;
  endcomp;
  compute after region/ style=Header;
     line ' ';
  endcomp;
  compute product;
    if upcase(_break_) = 'REGION' then product=catx(' ',region,'Total');
	else if _break_ = '_RBREAK_' then product = 'Grand Total';
  endcomp;
run;

proc report data=shoes spanrows
     style(summary)=Header;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 3b2) COMPUTE BEFORE/AFTER with LINE';
  column region product sales returns Profit inventory PctInv ;
  define region / group noprint;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  rbreak after / summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before region/ style=Header{just=c fontweight=bold fontsize=12pt};
     line region $varying100.;
	 brktxt = ' ';
	 if region = 'Canada' then reglg = 0;
     else reglg = 1;
  endcomp;
  compute after region/ style=Header;
     line brktxt $varying. reglg;
  endcomp;
  compute product;
    if upcase(_break_) = 'REGION' then product=catx(' ',region,'Total');
	else if _break_ = '_RBREAK_' then product = 'Grand Total';
  endcomp;
run;

ods html(id=ex3b) close;

ods html(id=ex3c) file="&outpath\example3_COMPUTE_AFTER_target_BY.html";

proc report data=shoes spanrows
     style(summary)=Header;
  by region;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  title 'Ex 3ca) COMPUTE BEFORE/AFTER without Grand Total';
  column region product sales returns Profit inventory PctInv ;
  define region / group noprint;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  break after region/summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before _page_/ style=Header{just=c fontweight=bold fontsize=12pt};
     line region $varying100.;
  endcomp;
  compute product;
    if upcase(_break_) = 'REGION' then product=catx(' ',region,'Total');
  endcomp;
run;
title;

** same code without region produces "All Region Report";
proc report data=shoes spanrows
     style(summary)=Header;
  where region in ('Asia' 'Canada') and
        product in ('Boot' 'Sandal' 'Slipper');
  column product sales returns Profit inventory PctInv ;
  define product / group;
  define profit / computed f=dollar14.;
  define pctinv / computed f=percent9.2;
  rbreak after /summarize;
  compute pctinv;
    profit = sum(sales.sum,-1*returns.sum);
    pctinv = sales.sum / inventory.sum;
  endcomp;
  compute before _page_/ style=Header{just=c fontweight=bold fontsize=12pt};
     line 'All Regions';
  endcomp;
  compute product;
    if _break_ = '_RBREAK_' then product="Grand Total";
  endcomp;
run;


ods html(id=ex3c) close;

title; footnote;
   
